"use strict";

//check for the form submission
document.getElementById('myForm').addEventListener('submit', saveBookmark);
//saveBookmark function//
function saveBookmark(e) {
  //get input data after form submission
  let siteName = document.getElementById('siteName').value;
  let siteUrl = document.getElementById('siteUrl').value;
  //store the input values in an object
  let bookmark = {
      name: siteName,
      url: siteUrl
  };
  if (!validateForm(siteName, siteUrl)) {
      return false;
  }
  //check if bookmark already exists before saving to localStorage
  if (localStorage.getItem('bookmarks') === null) {
      //initialize an array
      let bookmarks = [];
      //add the bookmark object to the newly created array
      bookmarks.push(bookmark);
      //set the bookmark to localStorage
      localStorage.setItem('bookmarks', JSON.stringify(bookmarks));//we need to convert the object to strinf b4 saving to localstorage
  }else{
      //if there's something in Loacalstorage, we  fetch it
      let bookmarks = JSON.parse(localStorage.getItem('bookmarks'));//retrieve back as an object
      //Add existing bookmarks to the bookmark array
        bookmarks.push(bookmark);
        //re-set the existing bookmarks back to localStorage
       localStorage.setItem('bookmarks', JSON.stringify(bookmarks));
  } 
   //clear form data after submitting
   document.getElementById('myForm').reset();

  //re-fetch bookmarks
  fetchBookmarks(); 

//prevent form from  submitting
e.preventDefault();
}

//delete Bookmark
function deleteBookmark(url) {
  //fetcn bookmarks from Loacalstorage 
  let bookmarks  = JSON.parse(localStorage.getItem('bookmarks'));
  //loop through the bookmarks again
  for (let i = 0; i < bookmarks.length; i++) {
     //check if the current iteration is the one we want to delete
     if (bookmarks[i].url == url) {
         //remove from array
         bookmarks.splice(i, 1);
     }
      
  }
  //re-set bookmarks back to localStorage
  localStorage.setItem('bookmarks', JSON.stringify(bookmarks));

  //re-fetch bookmarks
  fetchBookmarks();
    
}



//fetch bookmarks
function fetchBookmarks() {
    //fetcn bookmarks from Loacalstorage to populate on the webpage
    let bookmarks = JSON.parse(localStorage.getItem('bookmarks'));//retrieve back as an object 
    //display bookmarks on webpage
    let bookmarksResults = document.getElementById('bookmarksResults');
    //build our output
    bookmarksResults.innerHTML = "";
    //loop through the bookmarks in localstorage and output them one by one
    for (let i = 0; i < bookmarks.length; i++) {
        let name = bookmarks[i].name;
        let url = bookmarks[i].url;

        bookmarksResults.innerHTML += '<div class="well">'+
                                       '<h3>'+ name +
                                       '<a class="btn btn-default" target="_blank" href="'+url+'"> Visit'+'</a>'+
                                       '<a onclick ="deleteBookmark(\''+url+'\')" class="btn btn-danger"> Delete'+'</a>'+
                                        '</h3>'+
                                        '</div>';
    }

}

//Validate form

function validateForm(siteName, siteUrl) {
        if (!siteName || !siteUrl) {
            alert('Pls fill in the form');
            return false;
        }
        //validate for url

        let expression = /[-a-zA-Z0-9@:%_\+.~#?&//=]{2,256}\.[a-z]{2,4}\b(\/[-a-zA-Z0-9@:%_\+.~#?&//=]*)?/gi;
        let regex = new RegExp(expression);
        if (!siteUrl.match(regex)) {
            alert('enter a valid url');
            return false;
        }

        return true;
}